#!/usr/bin/python -Wall

# ================================================================
# John Kerl
# kerl at math dot arizona dot edu
# 2007-09-06
# ================================================================

# ----------------------------------------------------------------
from math import *
import stats_m

import random

# ----------------------------------------------------------------
ell = 2
N = 1000#100000
myXs  = []
libXs = []
for k in range(0, N):
	U = random.random()
	myX  = -log(1-U)/ell
	libX = random.expovariate(ell)
	#print "%11.7f %11.7f" % (myX, libX)

	myXs.append(myX)
	libXs.append(libX)

myH  = stats_m.make_histogram(myXs,  0.0, 5.0, 10)
libH = stats_m.make_histogram(libXs, 0.0, 5.0, 10)
expH = []
for x in [0.0, 0.5, 1.0, 1.5, 2.0, 2.5, 3.0, 3.5, 4.0, 4.5]:
	expH.append(exp(-ell*x) - exp(-ell*(x+0.5)))
#print myH
#print libH
#print expH

n = len(myH)
for j in range(0, n):
	E = expH[j]
	M = myH[j]  / (1.0*N)
	L = libH[j] / (1.0*N)
	EM = E - M
	EL = E - L
	
	#E  *= 1000
	#M  *= 1000
	#L  *= 1000
	#EM *= 1000
	#EL *= 1000

	print "%11.7f %11.7f %11.7f %11.7f %11.7f" % (E, M, L, EM, EL)
