#!/usr/bin/python -Wall

from math import *
import stats_m

a =    1664525
b = 1013904223
mask = (1<<32) - 1
M = 1.0 * (1<<32)

ell = 2
I = 1
N = 100000
Vs = []

max = 0.0
min = 100.0

for k in range(0, N):
	U = I/M
	V = -log(1-U) / ell
	if (V < min):
		min = V
	if (V > max):
		max = V
	if (k < 8) or (N-k < 8):
		print "%4d %11.7f %11.7f" % (k, U, V)
	I = (a*I + b) & mask
	Vs.append(V)

print
print "min=", min
print "max=", max
print

H = stats_m.make_histogram(Vs, 0.0, 6.5, 13)
lo = 0.0
hi = 0.5
for i in range(0, len(H)):
	print "[%11.7f,%11.7f) %11d" % (lo, hi, H[i])
	lo += 0.5
	hi += 0.5
